SystemOrganization addCategory: #'DuinoBot-EtoysCompiler'!

!DuinoBotPlayer methodsFor: '*duinobot-etoyscompiler' stamp: 'Richo 10/23/2012 12:58'!
getDuinoBotMode
	^ self costume renderedMorph mode nameSymbol! !

!DuinoBotPlayer methodsFor: '*duinobot-etoyscompiler' stamp: 'Richo 10/23/2012 13:00'!
setDuinoBotMode: aSymbol
	self getDuinoBotMode = aSymbol ifTrue: [^self].
	self costume renderedMorph
		mode: (aSymbol caseOf: {
			[#direct] -> [DuinoBotDirectMode new].
			[#compiled] -> [DuinoBotCompiledMode new].
			} otherwise: [^self]).
	self updateScriptEditors! !

!DuinoBotPlayer methodsFor: '*duinobot-etoyscompiler' stamp: 'Richo 10/23/2012 15:53'!
updateScriptEditors
	"Horrible hack below"
	World allMorphsDo: [:morph | | viewer |
		"Update scripts category of all opened viewers"
		((morph isKindOf: StandardViewer)
		and: [morph playerScripted isKindOf: self class officialClass orOf: ArduinoPlayer]) 
			ifTrue: [morph updateScriptsCategory].
		"Also update closed viewers"
		((morph isKindOf: ViewerFlapTab) and: [(viewer := morph referent findA: StandardViewer) notNil])
			ifTrue: [viewer updateScriptsCategory].
		"Finally, update all opened script editors"
		((morph isKindOf: ScriptEditorMorph)
		and: [morph playerScripted isKindOf: self class officialClass orOf: ArduinoPlayer]) 
			ifTrue: [morph replaceRow1; minWidth: nil]]! !

!DuinoBotSketch methodsFor: '*duinobot-etoyscompiler' stamp: 'Richo 1/23/2013 18:23'!
getIRCode: pin
"long getIRCode(long pin)"
	<argTypes: #(CLong )>
	<c: 'getIRCode({1})'>
	<returnType: #(CLong)>! !

!DuinoBotSketch methodsFor: '*duinobot-etoyscompiler' stamp: 'Richo 2/7/2013 17:30'!
getRGMotorSpeed: motorID
	<argTypes: #(CLong )>
	<c: 'getRGMotorSpeed({1})'>
	<returnType: #(CLong)>! !

!DuinoBotSketch methodsFor: '*duinobot-etoyscompiler' stamp: 'Richo 10/24/2012 17:12'!
setRGMotorSpeed: speed motorID: motorID
	<argTypes: #(CLong CLong)>
	<c: 'setRGMotorSpeed({1}, {2})'>! !

ArduinoPlayerTranslator subclass: #DuinoBotPlayerTranslator
	instanceVariableNames: 'motorPins'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DuinoBot-EtoysCompiler'!

!DuinoBotPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 10/24/2012 17:44'!
allMorphs
	"Returns a collection with all the morphs composing the robot (it could contain nils)"
	^ super allMorphs, motorPins value flattened! !

!DuinoBotPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 10/23/2012 13:32'!
classCategory
	^ 'DuinoBotPrograms'! !

!DuinoBotPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 11/16/2012 17:44'!
classIncludes
	^ #('"DuinoBot.h"')! !

!DuinoBotPlayerTranslator methodsFor: 'initializing' stamp: 'Richo 10/24/2012 15:57'!
collectMorphs
	"Apart from digital and analog pins we also need to check the motor pins"
	| arduino |
	super collectMorphs.
	arduino := mainMorph arduino.
	motorPins := ((0 to: 1)
		collect: [:n | n -> OrderedCollection new]) as: Dictionary.
	World allMorphsDo: [:morph |
		((morph isKindOf: AttachableDeviceMorph)
		and: [morph isAttachedTo: mainMorph])
			ifTrue: [
				arduino motorPins do: [:pin |
					(morph device isAttachedToPin: pin)
						ifTrue: [(motorPins at: pin number) add: morph]
				]
		]
	]! !

!DuinoBotPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 10/23/2012 13:49'!
commonSuperclass
	^ DuinoBotSketch! !

!DuinoBotPlayerTranslator methodsFor: 'accessing-rules' stamp: 'Richo 10/24/2012 17:17'!
dcMotorRules
	| selfVar superRules |
	superRules := super dcMotorRules as: Dictionary.
	selfVar := self variable: 'self'.
	^ {
		#getSpeed -> [:node || morph | 
			morph := self morphFor: node receiver name.
			(morph isKindOf: RGMotorMorph)
				ifTrue: [self withCurrentMorph: morph
						do: [| device |
						device := currentMorph device.
						node arguments: {self literal: device motorID};
							selector: #getRGMotorSpeed:;
							receiver: selfVar].
					super acceptMessageNode: node]
				ifFalse: [(superRules at: #getSpeed) value: node]
			].
		#setSpeed: -> [:node || morph | 
			morph := self morphFor: node receiver name.
			(morph isKindOf: RGMotorMorph)
				ifTrue: [self withCurrentMorph: morph
						do: [| device |
						device := currentMorph device.
						node arguments: node arguments, 
								{self literal: device motorID};
							selector: #setRGMotorSpeed:motorID:;
							receiver: selfVar].
					super acceptMessageNode: node]
				ifFalse: [(superRules at: #setSpeed:) value: node]].
		}! !

!DuinoBotPlayerTranslator methodsFor: 'accessing-rules' stamp: 'Richo 1/23/2013 19:54'!
irRules
| selfVar |
selfVar := self variable: 'self'.
^ {
#getRemoteCode -> [:node | 
	self withCurrentMorph: (self morphFor: node receiver name) do: [
		node receiver: selfVar;
		  arguments: 	{self literal: (self arduinoIndexOf: node receiver)};
		  selector: #getIRCode:].	
	super acceptMessageNode: node].
}! !

!DuinoBotPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/23/2013 20:08'!
pinModeCodeFor: mode
	^ (mode isKindOf: IRMode)
		ifTrue: ['4']
		ifFalse: [super pinModeCodeFor: mode]! !

!DuinoBotPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 10/23/2012 13:50'!
programName
	^ #DuinoBotEtoysProgram! !

!DuinoBotPlayerTranslator methodsFor: 'accessing-rules' stamp: 'Richo 1/23/2013 19:51'!
rules
	^ super rules,  (self irRules as: Dictionary)! !

!DuinoBotPlayerTranslator methodsFor: 'accessing-rules' stamp: 'Richo 1/18/2013 18:42'!
soundRules
| selfVar installVariables soundDuration |
soundDuration := (#soundDuration, self hashString) asSymbol.
installVariables := [:morph |
	(variables at: morph) at: soundDuration put: #Number -> (self currentPlayer getDuration)].
selfVar := self variable: 'self'.
^ {
#setDuration: -> [:node | | newNode |
	self withCurrentMorph: (self morphFor: node receiver name) do: [
		installVariables value: currentMorph.
		newNode := self assignment: (self variable: (self asLegalName: soundDuration)) 
							to: node arguments first.
		node become: (newNode parent: node parent)].
	self visitNode: node].

#getDuration -> [:node | | newNode |
	self withCurrentMorph: (self morphFor: node receiver name) do: [
		installVariables value: currentMorph.
		newNode := self variable: (self asLegalName: soundDuration).
		node become: (newNode parent: node parent)].
	self visitNode: node].

#playTone: -> [:node | 
	self withCurrentMorph: (self morphFor: node receiver name) do: [
		installVariables value: currentMorph.
		node receiver: selfVar;
		  arguments: node arguments, 
					{self variable: (self asLegalName: soundDuration). 
					self literal: ([self arduinoIndexOf: node receiver]
						on: AssertionFailure
						do: [23 "BuzzerPin"])};
		  selector: #playTone:duration:pin:].	
	super acceptMessageNode: node].

#playNote: -> [:node | 
	self withCurrentMorph: (self morphFor: node receiver name) do: [
		installVariables value: currentMorph.
		node receiver: selfVar;
		  arguments: {self literal: (PEUtilities frequencyFor: node arguments first value ifAbsent: [0]).
					self variable: (self asLegalName: soundDuration). 
					self literal: ([self arduinoIndexOf: node receiver]
						on: AssertionFailure
						do: [23 "BuzzerPin"])};
		  selector: #playTone:duration:pin:].	
	super acceptMessageNode: node].
}! !

!DuinoBotMorph methodsFor: '*duinobot-etoyscompiler' stamp: 'Richo 10/23/2012 13:19'!
playerTranslator
	^ DuinoBotPlayerTranslator on: self! !

ArduinoCompiledMode subclass: #DuinoBotCompiledMode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DuinoBot-EtoysCompiler'!

!DuinoBotCompiledMode methodsFor: 'as yet unclassified' stamp: 'Richo 1/24/2013 16:21'!
attachIRReceiverToPin: pinNumber
	"Do nothing"! !

!DuinoBotCompiledMode methodsFor: 'as yet unclassified' stamp: 'Richo 1/24/2013 16:22'!
detachIRReceiverFromPin: pinNumber
	"Do nothing"! !

!DuinoBotCompiledMode methodsFor: 'as yet unclassified' stamp: 'Richo 1/24/2013 16:22'!
motorDC: motorIndex speed: pinValue
	"Do nothing"! !
